# -*- coding: UTF-8 -*-
from setuphelpers import *
import time

uninstallkey = []

def install():


    softname = 'Mozilla Firefox'
    versionsoft = control['version'].split('-',1)[0]


    check_installed = installed_softwares(softname)

    if check_installed:
             for uninstall in check_installed:
                   if not 'ESR' in uninstall['name'] :
                        print(u'remove Firefox not ESR' )
                        if uninstall_key_exists(uninstall['key']):
                            killalltasks('firefox.exe')
                            cmd = WAPT.uninstall_cmd(uninstall['key'])
                            run(cmd)
                            time.sleep (5)
                   if iswin64():
                      if 'x86' in uninstall['name'] :
                        print(u'remove Firefox x86 for install firefox x64' )
                        if uninstall_key_exists(uninstall['key']):
                            killalltasks('firefox.exe')
                            cmd = WAPT.uninstall_cmd(uninstall['key'])
                            run(cmd)
                            time.sleep (5)


    print("Installing Firefox ESR file")

    key='Mozilla Firefox %s ESR (x64 fr)' % versionsoft
    install_exe_if_needed('Firefox Setup %sesr_x64.exe' % versionsoft ,silentflags='-ms',key=key ,min_version=versionsoft,killbefore=['firefox.exe'])
    remove_desktop_shortcut('Mozilla Firefox')
    remove_desktop_shortcut('Firefox')

    for mms in installed_softwares('MozillaMaintenanceService'):
        if uninstall_key_exists(mms['key']):
            run(uninstall_cmd(mms['key']))

    registry_set(HKEY_LOCAL_MACHINE,'SOFTWARE\\Policies\\Mozilla\\Firefox','DisableAppUpdate',1,REG_DWORD)


def update_package():
    """ You can do a CTRL F9 in pyscripter to update the package """
    import re,requests,glob

    # Download x64
    url = requests.head('https://download.mozilla.org/?product=firefox-esr-next-latest-ssl&os=win64&lang=fr',proxies={}).headers['Location']
    filename = url.rsplit('/',1)[1].replace('.exe','_x64.exe').replace('%20',' ')
    if not isfile(filename):
        print('Downloading %s from %s'%(filename,url))
        wget(url,filename)

    # Removes old exe x64
    exes = glob.glob('*.exe')
    for fn in exes:
        if fn != filename:
            remove_file(fn)

    if not isfile(filename):
        print('Downloading %s from %s'%(filename,url))
        wget(url,filename)

    control.version = '%s-0'%(re.findall('Firefox Setup (.*)esr\_x64.exe',filename)[0])
    control.save_control_to_wapt()

def session_setup():

    listlnk = []
    try:
        listlnk.extend(find_all_files(makepath(user_appdata(),'Microsoft','Internet Explorer','Quick Launch', 'User Pinned'),'*.lnk'))
    except:
        pass
    try:
        listlnk.extend(glob.glob(makepath(user_desktop(),'*.lnk')))
    except:
        pass
    try:
        listlnk.extend(find_all_files(winshell.programs(0),'*.lnk'))
    except:
        pass
    try:
        listlnk.extend(find_all_files(makepath(user_appdata(),'ClassicShell', 'Pinned'),'*.lnk'))
    except:
        pass

    #Fix missing shortcut if path not found
    if iswin64():
        exe = makepath(installed_softwares('Mozilla Firefox')[0]['install_location'],'firefox.exe')
        for lnk in listlnk :
            try:
                if get_shortcut_properties(lnk)['path'].lower().endswith('firefox.exe'):
                    if isfile(get_shortcut_properties(lnk)['path'].lower()):
                        continue
                    arg = get_shortcut_properties(lnk)['arguments']
                    remove_file(lnk)
                    create_shortcut(lnk,exe,arguments=arg)
            except:
                pass
